package  
{
	import aze.motion.easing.Elastic;
	import aze.motion.easing.Expo;
	import aze.motion.eaze;

	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.system.LoaderContext;

	/**
	 * @author mrdoob
	 */
	public class Avatar extends Sprite 
	{
		private var _loader : Loader;
		
		private var _frame : Sprite;
		private var _bitmap : Bitmap;
		
		
		// private var _text : TextField;
		
		private var _screen_name : String;
		
		public function Avatar(screen_name : String, filepath : String)
		{
			_screen_name = screen_name;
			
			mouseChildren = false;
			
			if (!filepath)
				return;
			/*
			_text = new TextField();
			_text.defaultTextFormat = new TextFormat("Trade Gothic", 5, 0xffffff, true);
			_text.embedFonts = true;
			_text.text = _name;
			_text.autoSize = TextFieldAutoSize.LEFT;
			_text.x = -_text.width / 2;
			_text.alpha = 0;
			_text.visible = false;
			_text.background = true;
			_text.backgroundColor = 0xff0000;
			addChild(_text);	
			*/
			_loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoadComplete);
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onIOError);
			_loader.load(new URLRequest(filepath), new LoaderContext(true));
		}
		
		private function onLoadComplete( event : Event ) : void
		{
			parent.swapChildrenAt(parent.numChildren - 1, parent.getChildIndex(this));
			
			_frame = new Sprite();
			_frame.graphics.beginFill(0xff0000, 1);
			_frame.graphics.drawRect(-8, -8, 16, 16);
			_frame.graphics.endFill();
			_frame.visible = false;
			addChild(_frame);
			
			_bitmap = Bitmap(LoaderInfo(event.target).content);
			_bitmap.x = -8;
			_bitmap.y = -8;
			_bitmap.width = 16;
			_bitmap.height = 16;
			_bitmap.smoothing = true;
			// _bitmap.transform.colorTransform = new ColorTransform(1, .5, .5);
			addChild(_bitmap);

			scaleX = scaleY = 3;			
			rotation = Math.random() * 200 - 100;

			// var side : Number = Math.random() < .5 ? 1 : - .5;
			var tempX : uint = x;
			var tempY : uint = y; 	

			x = stage.stageWidth;
			y = Math.random() * 512;

			eaze(this)
				.to(4, {x : tempX, y : [Math.random() * 512, tempY], rotation : Math.random() * 100 - 50, scale : 0.7 }, false)
				.easing(Expo.easeOut)
				.onComplete(onAnimationInComplete);			
		}

		private function onIOError( event : Event ) : void
		{

		}

		private function onAnimationInComplete( ) : void
		{
			buttonMode = true;
						
			addEventListener(MouseEvent.ROLL_OVER, onRollOver);
			addEventListener(MouseEvent.ROLL_OUT, onRollOut);
			addEventListener(MouseEvent.CLICK, onClick);
		}		
		
		private function onRollOver( event : MouseEvent ) : void
		{
			parent.swapChildrenAt(parent.numChildren - 1, parent.getChildIndex(this));
			
			_frame.visible = true;
			
			eaze(this).to(.5, {rotation : 0, scale : 3 }).easing(Expo.easeOut);
			eaze(_frame).to(.5, {scale : 1.1 }).easing(Expo.easeOut);			
		}
		
		private function onRollOut( event : MouseEvent ) : void
		{
			eaze(this).to(4, {rotation : Math.random() * 100 - 50, scale : 0.7 }).easing(Expo.easeOut);
			eaze(_frame).to(4, {scale : 1 }).easing(Expo.easeOut).onComplete(onRollOutComplete);			
		}
		
		private function onRollOutComplete() : void
		{
			_frame.visible = false;
		}
		
		private function onClick( event : MouseEvent ) : void
		{
			navigateToURL(new URLRequest("http://twitter.com/" + _screen_name), "_blank");	
		}
	}
}
