package 
{
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFormat;

	/**
	 * @author mrdoob
	 */
	public class Retriever extends Sprite 
	{
		private var _loader : URLLoader;
		private var _cursor : String = "-1";
		
		private var data : TextField;
		private var progress : TextField;
		
		public function Retriever() 
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			_loader = new URLLoader();
			_loader.addEventListener(Event.COMPLETE, onLoadComplete);
			_loader.addEventListener(IOErrorEvent.IO_ERROR, onIOError);
			
			data = new TextField();
			data.defaultTextFormat = new TextFormat("_sans");
			data.width = 1024;
			data.height = 768;
			data.multiline = true;
			data.wordWrap = true;
			addChild(data);
			
			progress = new TextField();
			progress.defaultTextFormat = new TextFormat("_sans");			
			progress.width = 1024;
			progress.y = 768;
			addChild(progress);			
			
			load();
		}
		
		private function load() : void
		{
			var url : String = "http://twitter.com/statuses/followers/mrdoob.xml?cursor=" + _cursor;
			progress.text = url;
			_loader.load(new URLRequest(url));
		}

		private function onIOError( event : Event ) : void
		{
			load();
		}

		private function onLoadComplete( event : Event ) : void
		{
			var xml : XML = new XML(event.target.data);
			
			var users : XML = xml.children()[0];
			
			for (var i : uint = 0; i < users.children().length(); i++)
			{
				var node : XML = users.children()[i];
				data.appendText(node.screen_name + "|" + node.profile_image_url + "|");
			}
			
			_cursor = xml.children()[1].valueOf();
			
			if (_cursor == "0")
			{
				progress.text = "DONE!";
				return;
			}
			
			load();
		}
	}
}